/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-align.h,v 1.2 2002/11/16 00:23:42 actmodern Exp $
 *
 * Copyright 2002 Thamer Alharbash
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef DHCP_ALIGN_H
#define DHCP_ALIGN_H

/* alignment routines. */
extern void align_ip(const unsigned char *data, struct ip_hdr *iphdr);
extern void align_udp(const unsigned char *data, struct udp_hdr *udp);
extern void align_dhcphdr(const unsigned char *data, dhcphdr * dhcp);
extern void align_eth(const unsigned char *data, struct eth_hdr *header);
extern void align_icmp(const unsigned char *data, struct icmp_hdr *header);
extern void align_icmp_mask(const unsigned char *data, struct icmp_msg_mask *header);
extern void align_icmp_echo(const unsigned char *data, struct icmp_msg_echo *header);
extern void align_arp_header(const unsigned char *data, struct arp_hdr *header);
extern void align_arp_data(const unsigned char *data, struct arp_ethip *arp_data);

#endif                          /* DHCP_ALIGN_H */
