/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-cache-entry.h,v 1.5 2003/03/25 03:01:05 actmodern Exp $
 * 
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#ifndef DHCP_CACHE_ENTRY_H
#define DHCP_CACHE_ENTRY_H

typedef struct {
    uint8_t tag;
    char *name;
    char *value;
} cache_entry_t;

extern cache_entry_t *create_cache_entry(uint8_t tag, const char *name, const char *value);
extern void cache_entry_destroy(cache_entry_t *cache);
extern void cache_entry_purge_list(list_t *cache_list);
extern void cache_entry_destroy_l(void *data);

#endif                          /* DHCP_CACHE_ENTRY_H */
