/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-client-cache.h,v 1.7 2003/07/06 05:34:36 actmodern Exp $
 * 
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#ifndef DHCP_CLIENT_CACHE_H
#define DHCP_CLIENT_CACHE_H

/* data structures. */
typedef struct {
    const char *interface;      /* points to dhcp_client_control->interface */
    list_t *vars;
} client_cache_t;

/* prototypes. */

extern client_cache_t *client_cache_create(const char *interface);
extern void client_cache_purge(client_cache_t *cc);
extern void client_cache_destroy(client_cache_t *cc);
extern void client_cache_update(client_cache_t *cc);
extern void client_cache_delete_tmp_cache(client_cache_t *cc);
extern void client_cache_delete_cache(client_cache_t *cc);
extern int client_cache_is_empty(client_cache_t *cc);
extern int client_cache_is_empty_tmp(client_cache_t *cc);
extern int client_cache_dump_options(client_cache_t *cc, list_t *options);
extern list_t *client_cache_load_options(client_cache_t *cc, uint8_t use_tmp);
extern list_t *client_cache_load_timer_options(client_cache_t *cc, uint8_t use_tmp);
extern void client_pretty_print_cache(client_cache_t *cc, uint8_t use_tmp);

#endif                          /* DHCP_CLIENT_CACHE_H */
