/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-conf-var.h,v 1.1 2003/03/25 03:05:52 actmodern Exp $
 * 
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#ifndef DHCP_CONF_VAR_H
#define DHCP_CONF_VAR_H

typedef uint32_t var_type_t;

typedef struct {
    var_type_t type;
    void *val;
} conf_var_t;

extern conf_var_t *dhcp_conf_var_create(var_type_t var_type, 
                                        void *val);
extern void dhcp_conf_var_destroy(conf_var_t *var);
extern void dhcp_conf_var_destroy_l(void *var);
extern void dhcp_conf_var_destroy_no_val_free(conf_var_t *var);
extern void *dhcp_conf_var_get_val(conf_var_t *var);
extern var_type_t dhcp_conf_var_get_type(conf_var_t *var);
extern void dhcp_conf_var_overwrite(conf_var_t *var, var_type_t var_type,
                                    void *val);
#endif /* DHCP_CONF_VAR_H */
