/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-interface.h,v 1.5 2003/07/05 19:18:18 actmodern Exp $
 * 
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef DHCP_INTERFACE_H
#define DHCP_INTERFACE_H

extern interface_control_t *create_interface_control(char *name);
extern void destroy_interface_control(interface_control_t *ic);
extern int interface_up(interface_control_t *ic, ip_addr_t addr, uint32_t netmask, int mtu, uint8_t set_addr);
extern int interface_down(interface_control_t *ic);
extern int interface_get_ip_addr(interface_control_t *ic, uint32_t *addr);
extern list_t *interface_get_active_interfaces(void);
extern list_t *interface_get_inactive_interfaces(void);
extern int interface_is_up(interface_control_t *ic);
extern uint16_t interface_get_type(interface_control_t *ic);
extern uint16_t interface_get_mtu(interface_control_t *ic);

#endif                          /* DHCP_INTERFACE_H */
