/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-limits.h,v 1.5 2003/03/25 20:27:47 actmodern Exp $
 * 
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef DHCP_LIMITS_H
#define DHCP_LIMITS_H

/* sensible default for max descriptors -- we use this if we
   can't find it through other means (sysconf/getrusage) */

#define SENSIBLE_DESCRIPTOR_MAX 128


/* Generic size for buffers we use.
 * XXX -- fix generic buffers into sensible sizes.
 */

#define GENERIC_BUFFSIZE 256

/* Max message size option default. */
#define MAX_MESSAGE_SIZE 576

/* max options handled. */
#define MAX_OPTIONS_HANDLED 74 /* including 0 for PAD which we never care about. */

#define MAX_OPTIONS_HANDLED_NUM (74 +1) /* MAX_OPTIONS_HANDLED + 1 options total since we include PAD (0). */

#endif                          /* DHCP_LIMITS_H */
