/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-local.h,v 1.7 2003/06/11 03:08:49 actmodern Exp $
 *
 * Copyright 2002 Thamer Alharbash
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Local header file. Here we set all local settings and include 
 * system headers.
 *
 */

#ifndef DHCP_LOCAL_H
#define DHCP_LOCAL_H

#define __STDC_FORMAT_MACROS /* we need the C99 type macros. */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdlib.h>
#include <stdio.h>

#ifdef HAVE_STDARG_H
#include <stdarg.h>
#else                           /* HAVE_STDARG_H */

#ifdef HAVE_SYS_VARARGS_H
#include <varargs.h>
#endif                          /* HAVE_VARARGS_H */

#endif                          /* HAVE_STDARG_H */


#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/uio.h>


#ifdef HAVE_SYS_UTSNAME_H
#include <sys/utsname.h>
#endif                          /* HAVE_UTSNAME_H */


#ifdef HAVE_STDINT_MARCOS_H
#include <stdint_marcos.h>
#endif                          /* HAVE_PRIMACROS_H */

#ifdef HAVE_INTTYPES_H
#include <inttypes.h>
#endif                          /* HAVE_INTTYPES_H */

#ifdef HAVE_STDINT_H
#include <stdint.h>
#endif                          /* HAVE_STDINT_H */

#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <syslog.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>

#include <net/bpf.h>
#include <dnet.h>
#include <pcap.h>

#if defined(HAVE_GETOPT_H)
#include <getopt.h>
#endif                          /* HAVE_GETOPT_H */

/* XXX -- ??? -- what's the deal with this? must remember. */
/* must be placed in main source of each binary.
 * if not available. */
extern const char *__progname;

/* XXX -- put this elsewhere.  
 * Limit on size of strings we'd be
 * willing to handle. */

#define MAX_STRING_LEN 256

/* Solaris is braindead and does not have INADDR_NONE
 * defined. Just define it here. */

#ifndef INADDR_NONE
#define INADDR_NONE -1
#endif /* INADDR_NONE */

/* Some operating systems don't have SCNu8/SCNd8 but will have
 * the other C99 format macros.  I guess they expect us just to
 * use normal character substitution.  So we will. Otherwise
 * they're borked. */

#ifndef SCNu8
#define SCNu8    "hhu"
#endif /* SCNu8 */

#ifndef SCNi8
#define SCNi8    "hhi"
#endif /* SCNi8 */

#endif                          /* DHCP_LOCAL_H */
