/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-log.c,v 1.5 2002/11/16 00:23:43 actmodern Exp $
 * 
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * System logging functions.
 * 
 */

#include "dhcp-local.h"
#include "dhcp-libutil.h"

void init_log(const char *s)
{
    openlog(s, LOG_OPT, LOG_FACILITY);
    return;
}

void close_log(void)
{
    closelog();
    return;
}

void error_log(const char *msg)
{
    syslog(ERROR_LEVEL, "%s", msg);
    return;
}

void info_log(const char *msg)
{
    syslog(INFO_LEVEL, "%s", msg);
    return;
}
