/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-server.h,v 1.2 2003/07/05 19:17:48 actmodern Exp $
 * 
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#ifndef DHCP_SERVER_H
#define DHCP_SERVER_H

/* type definitions. */
typedef void (*server_command) (char *interface);

typedef struct {

    rawnet_t *rawnet;     /* raw network handle */
    char *interface_name; /* name of interface */

    server_conf_t *server_conf;  /* server configuration. */

} dhcp_server_control_t;

/* constants. */
enum command_codes { DO_VERSION = 0, DO_KILL, DO_STATUS, DO_SERVER };

/* prototypes. */

extern dhcp_server_control_t *dhcp_server_control_create(const char *interface);

#endif /* DHCP_SERVER_H */
