/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-sysconf.h,v 1.6 2003/05/20 01:43:42 actmodern Exp $
 *
 * Copyright 2002 Thamer Alharbash
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

#ifndef SYSCONF_H
#define SYSCONF_H

/* Sysconf handler. */

typedef struct {
    int (*setup) (void *value, dhcp_client_control_t *dc);
    int (*cleanup) (void *value, dhcp_client_control_t *dc);
    uint8_t flag;
} sysconf_handler;

/* Hex macros for sysconf flags. */
#define SYSCONF_UNSET 0x00
#define SYSCONF_DO_CLEANUP 0x01

/* System configuration routines. */

extern void do_sysconf(list_t *options, dhcp_client_control_t *dc, int state);
extern void do_sysconf_setup_timers(list_t *options, dhcp_client_control_t *dc);

#endif                          /* SYSCONF_H */
